"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var babel_plugin_macros_1 = require("babel-plugin-macros");
var convertProperty_1 = require("./convertProperty");
var Parser_1 = require("./Parser");
var TailwindConfig_1 = require("./TailwindConfig");
exports.default = babel_plugin_macros_1.createMacro(macro);
function macro(_a) {
    var references = _a.references, babel = _a.babel, path = _a.path;
    var _b = references.default, items = _b === void 0 ? [] : _b;
    var p = require("path").join(process.cwd(), "../", "input.css");
    console.log("css path: " + p);
    var parser = new Parser_1.Parser(p, TailwindConfig_1.defaultConfig);
    var parsed = parser.parse();
    items.forEach(function (reference) {
        if (!reference.parentPath.node.quasi) {
            return;
        }
        var text = reference.parentPath.node.quasi.quasis[0].value;
        var requestedClasses = text.raw.split(" ").filter(function (x) { return x; });
        var result = "(() => { \n        let result = {};\n        " + requestedClasses
            .map(function (name) {
            var clazz = parsed.filter(function (x) { return x.name === name; })[0];
            var classContent = "";
            if (!clazz) {
                console.warn("unknown tailwind css class \"" + name + "\"");
            }
            else {
                for (var _i = 0, _a = clazz.properties; _i < _a.length; _i++) {
                    var prop = _a[_i];
                    if (!clazz.condition) {
                        classContent += "result = {...result, ...{ " + convertProperty_1.convertProperty({
                            prop: prop,
                            clazz: clazz
                        }) + "}}";
                    }
                    else {
                        classContent += "\n                  if (" + clazz.condition + ") {\n                    result = {...result, ...{ " + convertProperty_1.convertProperty({
                            prop: prop,
                            clazz: clazz
                        }) + "}} \n                  }\n                  ";
                    }
                }
            }
            return classContent;
        })
            .join("\n") + "\n        return result;\n      })()";
        reference.parentPath.replaceWithSourceString(result);
    });
}
