module.exports = function(wallaby) {
  process.env.NODE_ENV = "test";

  return {
    files: [
      "./package.json",
      "./tsconfig.json",
      "src/**/*.yaml",
      "src/**/*.json",
      "src/**/*.ts?(x)",
      "src/**/*.gql",
      "!src/**/*spec.ts?(x)",
      "!src/**/*test.ts?(x)"
    ],

    tests: ["src/**/*spec.ts?(x)", "src/**/*test.ts?(x)"],

    env: {
      type: "node"
    },

    compilers: {
      "src/**/*.ts?(x)": wallaby.compilers.typeScript({
        module: "commonjs",
        jsx: "React"
      })
    },

    testFramework: "jest",

    debug: false,

    setup: function() {
      wallaby.testFramework.configure(require("./package.json").jest);
    }
  };
};
